<?php
class ControllerModuleNews extends Controller {
	protected function index() {
		$this->data['template'] = $this->config->get('config_template');
		$this->load->language('module/news');
		$this->data['heading_title'] = $this->language->get('heading_title');
		$this->data['text_read_more'] = $this->language->get('text_read_more');
		$this->data['text_date_added'] = $this->language->get('text_date_added');
		$this->load->model('fido/news');
		$this->load->model('tool/seo_url');
		$this->data['news_count'] = $this->model_fido_news->getTotalNews();
		$this->data['news'] = array();
		$results = $this->model_fido_news->getNewsShorts($this->config->get('news_limit'));
		foreach ($results as $result) {
		
		$cut_descr_symbols = $this->config->get('news_module_chars');
			$descr_plaintext = strip_tags(html_entity_decode($result['description'], ENT_QUOTES, 'UTF-8'));
			if( mb_strlen($descr_plaintext, 'UTF-8') > $cut_descr_symbols )
			{
			$descr_plaintext = mb_substr($descr_plaintext, 0, $cut_descr_symbols, 'UTF-8');
			}
			$this->data['news'][] = array(
				'title'        => $result['title'],
				'description' => $descr_plaintext,
				'href'         => $this->model_tool_seo_url->rewrite(HTTP_SERVER . 'index.php?route=information/news&news_id=' . $result['news_id']),
				'date_added'   => date($this->language->get('date_format_short'), strtotime($result['date_added']))
			);
		}
		$this->id = 'news';
		if ($this->config->get('news_position') == 'home') {
			if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/module/news_home.tpl')) {
				$this->template = $this->config->get('config_template') . '/template/module/news_home.tpl';
			} else {
				$this->template = 'default/template/module/news_home.tpl';
			}
		} else {
			if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/module/news.tpl')) {
				$this->template = $this->config->get('config_template') . '/template/module/news.tpl';
			} else {
				$this->template = 'default/template/module/news.tpl';
			}
		}
		$this->render();
	}
}
?>
